Submitted By: Jim Gifford (patches at jg555 dot com)
Date: 2005-08-27
Initial Package Version: 4.x
Origin: Ken Moffat and Jim Gifford
Upstream Status: LFS Specific
Description: Make LIB64 builds in /lib instead of /lib64 

diff -Naur gcc-4.0.1.orig/gcc/config/i386/linux64.h gcc-4.0.1/gcc/config/i386/linux64.h
--- gcc-4.0.1.orig/gcc/config/i386/linux64.h	2004-11-27 22:29:34.000000000 +0000
+++ gcc-4.0.1/gcc/config/i386/linux64.h	2005-08-28 05:07:59.000000000 +0000
@@ -60,8 +60,8 @@
   %{!shared: \
     %{!static: \
       %{rdynamic:-export-dynamic} \
-      %{m32:%{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2}} \
-      %{!m32:%{!dynamic-linker:-dynamic-linker /lib64/ld-linux-x86-64.so.2}}} \
+      %{m32:%{!dynamic-linker:-dynamic-linker /lib32/ld-linux.so.2}} \
+      %{!m32:%{!dynamic-linker:-dynamic-linker /lib/ld-linux-x86-64.so.2}}} \
     %{static:-static}}"
 
 #define MULTILIB_DEFAULTS { "m64" }
diff -Naur gcc-4.0.1.orig/gcc/config/i386/t-linux64 gcc-4.0.1/gcc/config/i386/t-linux64
--- gcc-4.0.1.orig/gcc/config/i386/t-linux64	2002-11-28 14:47:02.000000000 +0000
+++ gcc-4.0.1/gcc/config/i386/t-linux64	2005-08-28 05:08:37.000000000 +0000
@@ -6,7 +6,7 @@
 
 MULTILIB_OPTIONS = m64/m32
 MULTILIB_DIRNAMES = 64 32 
-MULTILIB_OSDIRNAMES = ../lib64 ../lib
+MULTILIB_OSDIRNAMES = ../lib ../lib32
 
 LIBGCC = stmp-multilib
 INSTALL_LIBGCC = install-multilib
diff -Naur gcc-4.0.1.orig/gcc/config/mips/linux64.h gcc-4.0.1/gcc/config/mips/linux64.h
--- gcc-4.0.1.orig/gcc/config/mips/linux64.h	2005-01-26 02:04:46.000000000 +0000
+++ gcc-4.0.1/gcc/config/mips/linux64.h	2005-08-28 05:09:17.000000000 +0000
@@ -47,9 +47,9 @@
       %{!static: \
         %{rdynamic:-export-dynamic} \
         %{!dynamic-linker: \
-	  %{mabi=n32: -dynamic-linker /lib32/ld.so.1} \
-	  %{mabi=64: -dynamic-linker /lib64/ld.so.1} \
-	  %{mabi=32: -dynamic-linker /lib/ld.so.1}}} \
+	  %{mabi=n32: -dynamic-linker /lib64/ld.so.1} \
+	  %{mabi=64: -dynamic-linker /lib/ld.so.1} \
+	  %{mabi=32: -dynamic-linker /lib32/ld.so.1}}} \
       %{static:-static}}} \
 %{mabi=n32:-melf32%{EB:b}%{EL:l}tsmipn32} \
 %{mabi=64:-melf64%{EB:b}%{EL:l}tsmip} \
diff -Naur gcc-4.0.1.orig/gcc/config/mips/t-linux64 gcc-4.0.1/gcc/config/mips/t-linux64
--- gcc-4.0.1.orig/gcc/config/mips/t-linux64	2005-01-17 21:09:14.000000000 +0000
+++ gcc-4.0.1/gcc/config/mips/t-linux64	2005-08-28 05:09:29.000000000 +0000
@@ -1,6 +1,6 @@
 MULTILIB_OPTIONS = mabi=n32/mabi=32/mabi=64
 MULTILIB_DIRNAMES = n32 32 64
-MULTILIB_OSDIRNAMES = ../lib32 ../lib ../lib64
+MULTILIB_OSDIRNAMES = ../lib64 ../lib32 ../lib
 
 EXTRA_MULTILIB_PARTS=crtbegin.o crtend.o crtbeginS.o crtendS.o crtbeginT.o
 
diff -Naur gcc-4.0.1.orig/gcc/config/rs6000/linux64.h gcc-4.0.1/gcc/config/rs6000/linux64.h
--- gcc-4.0.1.orig/gcc/config/rs6000/linux64.h	2005-04-29 00:19:47.000000000 +0000
+++ gcc-4.0.1/gcc/config/rs6000/linux64.h	2005-08-28 05:10:24.000000000 +0000
@@ -351,11 +351,11 @@
 
 #define LINK_OS_LINUX_SPEC32 "-m elf32ppclinux %{!shared: %{!static: \
   %{rdynamic:-export-dynamic} \
-  %{!dynamic-linker:-dynamic-linker /lib/ld.so.1}}}"
+  %{!dynamic-linker:-dynamic-linker /lib32/ld.so.1}}}"
 
 #define LINK_OS_LINUX_SPEC64 "-m elf64ppc %{!shared: %{!static: \
   %{rdynamic:-export-dynamic} \
-  %{!dynamic-linker:-dynamic-linker /lib64/ld64.so.1}}}"
+  %{!dynamic-linker:-dynamic-linker /lib/ld64.so.1}}}"
 
 #undef  TOC_SECTION_ASM_OP
 #define TOC_SECTION_ASM_OP \
diff -Naur gcc-4.0.1.orig/gcc/config/rs6000/t-linux64 gcc-4.0.1/gcc/config/rs6000/t-linux64
--- gcc-4.0.1.orig/gcc/config/rs6000/t-linux64	2004-03-17 15:15:32.000000000 +0000
+++ gcc-4.0.1/gcc/config/rs6000/t-linux64	2005-08-28 05:10:04.000000000 +0000
@@ -13,7 +13,7 @@
 MULTILIB_EXTRA_OPTS     = fPIC mstrict-align
 MULTILIB_EXCEPTIONS     = m64/msoft-float
 MULTILIB_EXCLUSIONS     = m64/!m32/msoft-float
-MULTILIB_OSDIRNAMES	= ../lib64 ../lib nof
+MULTILIB_OSDIRNAMES	= ../lib ../lib32 nof
 MULTILIB_MATCHES        = $(MULTILIB_MATCHES_FLOAT)
 
 # We want fine grained libraries, so use the new code to build the
diff -Naur gcc-4.0.1.orig/gcc/config/sparc/linux64.h gcc-4.0.1/gcc/config/sparc/linux64.h
--- gcc-4.0.1.orig/gcc/config/sparc/linux64.h	2005-04-04 15:32:00.000000000 +0000
+++ gcc-4.0.1/gcc/config/sparc/linux64.h	2005-08-28 05:11:35.000000000 +0000
@@ -167,21 +167,21 @@
   { "link_arch_default", LINK_ARCH_DEFAULT_SPEC },	  \
   { "link_arch",	 LINK_ARCH_SPEC },
     
-#define LINK_ARCH32_SPEC "-m elf32_sparc -Y P,/usr/lib %{shared:-shared} \
+#define LINK_ARCH32_SPEC "-m elf32_sparc -Y P,/usr/lib32 %{shared:-shared} \
   %{!shared: \
     %{!ibcs: \
       %{!static: \
         %{rdynamic:-export-dynamic} \
-        %{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2}} \
+        %{!dynamic-linker:-dynamic-linker /lib32/ld-linux.so.2}} \
         %{static:-static}}} \
 "
 
-#define LINK_ARCH64_SPEC "-m elf64_sparc -Y P,/usr/lib64 %{shared:-shared} \
+#define LINK_ARCH64_SPEC "-m elf64_sparc -Y P,/usr/lib %{shared:-shared} \
   %{!shared: \
     %{!ibcs: \
       %{!static: \
         %{rdynamic:-export-dynamic} \
-        %{!dynamic-linker:-dynamic-linker /lib64/ld-linux.so.2}} \
+        %{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2}} \
         %{static:-static}}} \
 "
 
@@ -257,12 +257,12 @@
 #else /* !SPARC_BI_ARCH */
 
 #undef LINK_SPEC
-#define LINK_SPEC "-m elf64_sparc -Y P,/usr/lib64 %{shared:-shared} \
+#define LINK_SPEC "-m elf64_sparc -Y P,/usr/lib %{shared:-shared} \
   %{!shared: \
     %{!ibcs: \
       %{!static: \
         %{rdynamic:-export-dynamic} \
-        %{!dynamic-linker:-dynamic-linker /lib64/ld-linux.so.2}} \
+        %{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2}} \
         %{static:-static}}} \
 %{mlittle-endian:-EL} \
 %{!mno-relax:%{!r:-relax}} \
diff -Naur gcc-4.0.1.orig/gcc/config/sparc/t-linux64 gcc-4.0.1/gcc/config/sparc/t-linux64
--- gcc-4.0.1.orig/gcc/config/sparc/t-linux64	2004-04-01 16:05:20.000000000 +0000
+++ gcc-4.0.1/gcc/config/sparc/t-linux64	2005-08-28 05:12:02.000000000 +0000
@@ -1,6 +1,6 @@
 MULTILIB_OPTIONS = m64/m32
 MULTILIB_DIRNAMES = 64 32
-MULTILIB_OSDIRNAMES = ../lib64 ../lib
+MULTILIB_OSDIRNAMES = ../lib ../lib32
 
 LIBGCC = stmp-multilib
 INSTALL_LIBGCC = install-multilib
@@ -16,4 +16,4 @@
 
 CRTSTUFF_T_CFLAGS = `if test x$$($(GCC_FOR_TARGET) $(MULTILIB_CFLAGS) \
 				 -print-multi-os-directory) \
-			= x../lib64; then echo -mcmodel=medany; fi`
+			= x../lib; then echo -mcmodel=medany; fi`
